int Wheels=A2, Steering=A1, ServoAdj=A0;  // Define Analog Channels
int ADC_Resolution = 4095;                //ADC InputRange: 0-3V3; thus lsb=InputRange/2^12=0.8mV                
int ADC_Wheels, ADC_Steering, ADC_ServoAdj, Wheels_Mapped, Steering_Mapped, ServoAdj_Mapped; 
int FW_BW, L_R; 
const int SteeringQ=35, WheelsQ=27; // quiescent point steering & wheels
const int Hysteresis = 3;           // add hysteresis from quiescent point

void setup() {  
  Serial.begin(115200);
}


void loop() {

  //Steering Wheel 
  ADC_Steering = analogRead(Steering);
  Steering_Mapped = map(ADC_Steering,160,4095,1,63); //Decrease Resolution of Steering Wheels
  //Serial.println((String) "Steering_Mapped=" + Steering_Mapped); 
  if (Steering_Mapped > SteeringQ+Hysteresis) L_R = Steering_Mapped - (SteeringQ+Hysteresis);     // LEFT (positive value)
  else if (Steering_Mapped < SteeringQ-Hysteresis) L_R = (Steering_Mapped-SteeringQ+Hysteresis);  //RIGHT (negative value)
  else L_R=0;

  //4WD Movement
  ADC_Wheels = analogRead(Wheels);  
  Wheels_Mapped = map(ADC_Wheels,1270,4095,1,63); //Decrease Resolution of Wheels
  if (Wheels_Mapped > WheelsQ+Hysteresis) FW_BW = Wheels_Mapped - (WheelsQ+Hysteresis);    //FORWARD  (positive value)
  else if (Wheels_Mapped < WheelsQ-Hysteresis) FW_BW = (Wheels_Mapped-WheelsQ+Hysteresis); //BACKWARD (negative value)
  else FW_BW=0;

  //Servo adjustment (Steering Wheel alignment) 
  ADC_ServoAdj = analogRead(ServoAdj); 
  ServoAdj_Mapped = map(ADC_ServoAdj,0,4095,0,32); //Decrease Resolution of Servo trimming value
  ServoAdj_Mapped -= 16;


  Serial.println((String) "Forward/Backward=" + FW_BW + '\t' + "Left/Right=" + L_R + '\t' + "Steering Alignment=" + ServoAdj_Mapped); 
}
